# Overview

A Balance 12 layout for the Atreus keyboard.

Balance 12 was created by Sasha Viminitz. Please see [this page](https://mathematicalmulticore.wordpress.com/the-keyboard-layout-project/)
for some background on the design of the layout.

* The variant used here is a mirror of the original for left-handers
* The central column of punctuation keys has been moved elsewhere
* Home positions for the left and right forefingers are *T* and *A* respectively

## To build/flash

> make atreus:yttyx:avrdude

## Layers

### Base:

      .----------------------------------.         .------------------------------.
      | P    | L    | C    | D   | W     |         | U    | O   | Y   | K   | Q   |
      +------+------+------+-----+-------|         |------+-----+-----+-----+-----|
      | N    | R    | S    | T   | M     |         | A    | E   | I   | H   | V   |
      +------+------+------+-----+-------|         |------+-----+-----+-----+-----|
      | Z    | J    | F    | G   | B     |         | ,    | .   | ;   | X   | -   |
      +------+------+------+-----+-------+---------+------+-----+-----+-----+-----|
      | Shft | Ctl  | Alt  | BS  | Space | L1 | R1 | Shft | R2  | Win | Ctl | Alt |
      '---------------------------------------------------------------------------'

### L1:

      .---------------------------------.         .--------------------------------.
      | 1    | 2    | 3    | 4  | 5     |         | 6    | 7  | 8   | 9    | 0     |
      |------+------+------+----+-------|         |------+----+-----+------+-------|
      | Tab  | ?    | =    | -  | _     |         | '    | "  | +   | *    | Enter |
      |------+------+------+----+-------|         |------+----+-----+------+-------|
      | Esc  | !    | &    |    |       |         | ,    | .  | ;   |      | -     |
      |------+------+------+----+-------+---------+------+----+-----+------+-------|
      | Shft | Ctrl | Alt  | Bk | Space | L1 | R1 | Shft | R2 | Sup | Ctrl | Alt   |
      '----------------------------------------------------------------------------'

### R1:

      .---------------------------------.         .-------------------------------.
      | <    | >    | {   | }   | @     |         | $    |   |     |      | R3   |
      +------+------+-----+-----|-------|         |------+----+-----+------+------|
      | [    | ]    | (   | )   | #     |         | '    | "  | ~   | `    | Caps |
      |------+------+-----+-----+-------|         |------+----+-----+------+------|
      | /    | \    | ^   | |   | %     |         | ,    | .  | ;   |      | PScn |
      |------+------+-----+-----+-------+---------+------+----+-----+------+------|
      | Shft | Ctrl | Alt | Del | Space | L1 | R1 | Shft | R2 | Sup | Ctrl | Alt  |
      '---------------------------------------------------------------------------'

### R2:

      .-----------------------------------.         .--------------------.-----------------.
      | F12  | F11  | F10  | F9   | Copy  |         | Home | Up   | End  | PgUp | Insert   |
      |------+------+------+------+-------|         |------+------+------+------+----------|
      | F8   | F7   | F6   | F5   | Paste |         | Left | Down | Right| PgDn | Enter    |
      |------+------+------+------+-------|         |------+------+------+------+----------|
      | F4   | F3   | F2   | F1   | Cut   |         | ^Tab |      | Tab  |      |          |
      |------+------+------+------+-------+---------+------+------+------+------+----------|
      | Shft | Ctrl | Alt  | Del  | Undo  | L1 | R1 | Shft | R2   | Sup  | Ctrl | WinRight |
      '------------------------------------------------------------------------------------'

### R3:

      .----------------------------.         .------------------------.
      | RESET |    |     |    |    |         |    |    |    |    | R3 |
      |-------+----+-----+----+----|         |----+----+----+----+----|
      |       |    |     |    |    |         |    |    |    |    |    |
      |-------+----+-----+----+----|         |----+----+----+----+----|
      |       |    |     |    |    |         |    |    |    |    |    |
      |-------+----+-----+----+----+---------+----+----+----+----+----|
      |       |    |     |    |    |    |    |    |    |    |    |    |
      '---------------------------------------------------------------'

