# Keymap Maintainer: Gam3cat
make gonnerd:gam3cat
## Layout Config:
2u backspace, 2.25u left shift/enter, 1.75u right shift.
2x1.5u, 1x7.0u, 2x1.5u, 3x1u bottom row.

    FN_CAPS = MO(_FL) when held, CAPS when tapped.
    GRAVE_ESC + GUI = `
    GRAVE_ESC + SHIFT = ~

## Base Layer Selection:
(Caps+TAB+(  )): (Q)WERTY, (W)orkman, (N)orman, (D)vorak, (C)olmak

### Base Layer Options:
    _BL: Base Layer, mostly standard TKL QWERTY layout.
    .-----------------------------------------------------------------------.
    |Esc||||| F1| F2| F3| F4||| F5| F6| F7| F8||| F9|F10|F11|F12|PSc|SLk|Pau|
    |-----------------------------------------------------------|-----------|
    |  ~|  1|  2|  3|  4|  5|  6|  7|  8|  9|  0|  -|  =|Backsp |Ins|Hom|PgU|
    |-----------------------------------------------------------|-----------|
    |Tab  |  Q|  W|  E|  R|  T|  Y|  U|  I|  O|  P|  [|  ]|    \|Del|End|PgD|
    |-----------------------------------------------------------|-----------|
    |FnCaps|  A|  S|  D|  F|  G|  H|  J|  K|  L|  ;|  '|Return  |           |
    |-----------------------------------------------------------|-----------|
    |Shift   |  Z|  X|  C|  V|  B|  N|  M|  ,|  .|  /|Shift     |   | Up|   |
    |-----------------------------------------------------------|-----------|
    |Ctrl |||||Win  |      Space                |RAlt |||||Ctrl |Lft|Dwn|Rgt|
    *-----------------------------------------------------------------------*
    
    _WL: Workman Layer.
    .-----------------------------------------------------------------------.
    |   |||||   |   |   |   |||   |   |   |   |||   |   |   |   |   |   |   |
    .-----------------------------------------------------------|-----------|
    |   |   |   |   |   |   |   |   |   |   |   |  -|  =|       |   |   |   |
    |-----------------------------------------------------------|-----------|
    |     |  Q|  D|  R|  W|  B|  J|  F|  U|  P|  ;|  [|  ]|    \|   |   |   |
    |-----------------------------------------------------------|-----------|
    |      |  A|  S|  H|  T|  G|  Y|  N|  E|  O|  I|  '|        |           |
    |-----------------------------------------------------------|-----------|
    |        |  Z|  X|  M|  C|  V|  K|  L|  ,|  .|  /|      |   |   |   |   |
    |-----------------------------------------------------------|-----------|
    |     |||||     |                           |     |||||     |   |   |   |
    *-----------------------------------------------------------------------*
    
    _NL: Norman Layer.
    .-----------------------------------------------------------------------.
    |   |||||   |   |   |   |||   |   |   |   |||   |   |   |   |   |   |   |
    .-----------------------------------------------------------|-----------|
    |   |   |   |   |   |   |   |   |   |   |   |  -|  =|       |   |   |   |
    |-----------------------------------------------------------|-----------|
    |     |  Q|  W|  D|  F|  K|  J|  U|  R|  L|  ;|  [|  ]|    \|   |   |   |
    |-----------------------------------------------------------|-----------|
    |      |  A|  S|  E|  T|  G|  Y|  N|  I|  O|  H|  '|        |           |
    |-----------------------------------------------------------|-----------|
    |        |  Z|  X|  C|  V|  B|  P|  M|  ,|  .|  /|      |   |   |   |   |
    |-----------------------------------------------------------|-----------|
    |     |||||     |                           |     |||||     |   |   |   |
    *-----------------------------------------------------------------------*
    
    _DL: Dvorak Layer.
    .-----------------------------------------------------------------------.
    |   |||||   |   |   |   |||   |   |   |   |||   |   |   |   |   |   |   |
    .-----------------------------------------------------------|-----------|
    |   |   |   |   |   |   |   |   |   |   |   |  [|  ]|       |   |   |   |
    |-----------------------------------------------------------|-----------|
    |     |  '|  ,|  .|  P|  Y|  F|  G|  C|  R|  L|  /|  =|    \|   |   |   |
    |-----------------------------------------------------------|-----------|
    |      |  A|  O|  E|  U|  I|  D|  H|  T|  N|  S|  -|        |           |
    |-----------------------------------------------------------|-----------|
    |        |  ;|  Q|  J|  K|  X|  B|  M|  W|  V|  Z|      |   |   |   |   |
    |-----------------------------------------------------------|-----------|
    |     |||||     |                           |     |||||     |   |   |   |
    *-----------------------------------------------------------------------*
    
    _CL: Colmak Layer.
    .-----------------------------------------------------------------------.
    |   |||||   |   |   |   |||   |   |   |   |||   |   |   |   |   |   |   |
    .-----------------------------------------------------------|-----------|
    |   |   |   |   |   |   |   |   |   |   |   |  -|  =|       |   |   |   |
    |-----------------------------------------------------------|-----------|
    |     |  Q|  W|  F|  P|  G|  J|  L|  U|  Y|  ;|  [|  ]|    \|   |   |   |
    |-----------------------------------------------------------|-----------|
    |      |  A|  R|  S|  T|  D|  H|  N|  E|  I|  O|  '|        |           |
    |-----------------------------------------------------------|-----------|
    |        |  Z|  X|  C|  V|  B|  K|  M|  ,|  .|  /|      |   |   |   |   |
    |-----------------------------------------------------------|-----------|
    |     |||||     |                           |     |||||     |   |   |   |
    *-----------------------------------------------------------------------*
    
    _FL: Function Layer.
    M0 opens Chrome
    .-----------------------------------------------------------------------.
    |   |||||   |   |   |   |||   |   |   |   |||   |VlM|VlD|VlU|   |   |   |
    .-----------------------------------------------------------|-----------|
    | M0|   |   |   |   |   |   |   |   |   |   |   |   |       |   |   |   |
    |-----------------------------------------------------------|-----------|
    |     |   |   |   |   |   |   |   |   |   |   |   |   |     |   |   |   |
    |-----------------------------------------------------------|-----------|
    |      |   |   |   |   |   |   |Lft|Dwn|Up |Rgt|   |        |           |
    |-----------------------------------------------------------|-----------|
    |        |   |   |   |   |   |   |   |   |   |   |      |   |   |   |   |
    |-----------------------------------------------------------|-----------|
    |     |||||     |                           |     |||||     |WBk|   |WFw|
    *-----------------------------------------------------------------------*
    
    _AL: Adjust Layer.
    Default keymap, RGB Underglow, LED backlight, and Dynamic Macro settings.
    .-----------------------------------------------------------------------.
    |Rst|||||   |   |   |   |||   |   |   |   |||   |   |   |   |   |   |   |
    .-----------------------------------------------------------|-----------|
    |Ver|Tog|Mod|H- |H+ |S- |S+ |V- |V+ |   |BLT|BL-|BL+|       |   |MR1|MP1|
    |-----------------------------------------------------------|-----------|
    |Fn_AL|_BL|_WL|   |   |   |   |   |   |   |   |   |   |     | MS|MR2|MP2|
    |-----------------------------------------------------------|-----------|
    |FnCaps|   |   |_DL|   |   |   |   |   |   |   |   |        |           |
    |-----------------------------------------------------------|-----------|
    |        |   |   |_CL|   |_BL|_NL|   |   |   |   |      |   |   |   |   |
    |-----------------------------------------------------------|-----------|
    |     |||||     |                           |     |||||     |   |   |   |
    *-----------------------------------------------------------------------*
