# Keymap Maintainer: Gam3cat
make jc65/v32u4:gam3cat
## Layout Config:
2u backspace, 2.25u left shift/enter, 1.75u right shift.
(2x1.5u, 1x7.0u, 2x1.5u, 3x1u), (3x1.25u, 1x6.25u, 2x1.5u, 3x1u), or
(3x1.25u, 1x6.25u, 6x1u) bottom row.

    FN_CAPS = MO(_FL) when held, CAPS when tapped.
    GRAVE_ESC + GUI = `
    GRAVE_ESC + SHIFT = ~

## Base Layer Selection:
(Caps+TAB+(  )): (Q)WERTY, (W)orkman, (N)orman, (D)vorak, (C)olmak

### Base Layer Options:
#### _BL: Base Layer, mostly standard 65% QWERTY layout.
    .---------------------------------------------------------------.
    |GrE|  1|  2|  3|  4|  5|  6|  7|  8|  9|  0|  -|  =|Backsp |Ins|
    |---------------------------------------------------------------|
    |Tab  |  Q|  W|  E|  R|  T|  Y|  U|  I|  O|  P|  [|  ]|    \|Del|
    |---------------------------------------------------------------|
    |FnCaps|  A|  S|  D|  F|  G|  H|  J|  K|  L|  ;|  '|Return  |PgU|
    |---------------------------------------------------------------|
    |Shift   |  Z|  X|  C|  V|  B|  N|  M|  ,|  .|  /|Shift |Up |PgD|
    |---------------------------------------------------------------|
    |Ctrl|Gui |Alt |      Space             |RAlt |Ctrl |Lft|Dwn|Rgt|
    *---------------------------------------------------------------*

#### _WL: Workman Layer.
    .---------------------------------------------------------------.
    |   |   |   |   |   |   |   |   |   |   |   |  -|  =|       |   |
    |---------------------------------------------------------------|
    |     |  Q|  D|  R|  W|  B|  J|  F|  U|  P|  ;|  [|  ]|    \|   |
    |---------------------------------------------------------------|
    |      |  A|  S|  H|  T|  G|  Y|  N|  E|  O|  I|  '|        |   |
    |---------------------------------------------------------------|
    |        |  Z|  X|  M|  C|  V|  K|  L|  ,|  .|  /|      |   |   |
    |---------------------------------------------------------------|
    |    |    |    |                        |     |     |   |   |   |
    *---------------------------------------------------------------*

#### _NL: Norman Layer.
    .---------------------------------------------------------------.
    |   |   |   |   |   |   |   |   |   |   |   |  -|  =|       |   |
    |---------------------------------------------------------------|
    |     |  Q|  W|  D|  F|  K|  J|  U|  R|  L|  ;|  [|  ]|    \|   |
    |---------------------------------------------------------------|
    |      |  A|  S|  E|  T|  G|  Y|  N|  I|  O|  H|  '|        |   |
    |---------------------------------------------------------------|
    |        |  Z|  X|  C|  V|  B|  P|  M|  ,|  .|  /|      |   |   |
    |---------------------------------------------------------------|
    |    |    |    |                        |     |     |   |   |   |
    *---------------------------------------------------------------*

#### _DL: Dvorak Layer.
    .---------------------------------------------------------------.
    |   |   |   |   |   |   |   |   |   |   |   |  [|  ]|       |   |
    |---------------------------------------------------------------|
    |     |  '|  ,|  .|  P|  Y|  F|  G|  C|  R|  L|  /|  =|    \|   |
    |---------------------------------------------------------------|
    |      |  A|  O|  E|  U|  I|  D|  H|  T|  N|  S|  -|        |   |
    |---------------------------------------------------------------|
    |        |  ;|  Q|  J|  K|  X|  B|  M|  W|  V|  Z|      |   |   |
    |---------------------------------------------------------------|
    |    |    |    |                        |     |     |   |   |   |
    *---------------------------------------------------------------*

#### _CL: Colmak Layer.
    .---------------------------------------------------------------.
    |   |   |   |   |   |   |   |   |   |   |   |  -|  =|       |   |
    |---------------------------------------------------------------|
    |     |  Q|  W|  F|  P|  G|  J|  L|  U|  Y|  ;|  [|  ]|    \|   |
    |---------------------------------------------------------------|
    |      |  A|  R|  S|  T|  D|  H|  N|  E|  I|  O|  '|        |   |
    |---------------------------------------------------------------|
    |        |  Z|  X|  C|  V|  B|  K|  M|  ,|  .|  /|      |   |   |
    |---------------------------------------------------------------|
    |    |    |    |                        |     |     |   |   |   |
    *---------------------------------------------------------------*

### Function Layer: (hold Caps to access)
    M0 opens Chrome
#### _FL: Function Layer.
    .---------------------------------------------------------------.
    |M0 | F1| F2| F3| F4| F5| F6| F7| F8| F9|F10|F11|F12|SLock  |PSc|
    |---------------------------------------------------------------|
    |Fn_AL|   |   |   |   |   |   |   |   |   |   |   |   |     |Pau|
    |---------------------------------------------------------------|
    |FnCaps|   |   |   |   |   |Lft|Dwn|Up |Rgt|   |   |        |Hme|
    |---------------------------------------------------------------|
    |        |   |   |   |   |   |   |   |   |   |   |VlMute|VlU|End|
    |---------------------------------------------------------------|
    |    |    |Menu|                        |     |     |WBk|VlD|WFw|
    *---------------------------------------------------------------*

### Adjust Layer: (hold Caps+TAB to access)
    Default keymap, RGB Underglow, LED backlight, and Dynamic Macro settings.
#### _AL: Adjust Layer.
    .---------------------------------------------------------------.
    |Ver|Tog|Mod|H- |H+ |S- |S+ |V- |V+ |   |BLT|BL-|BL+|       |MP1|
    |---------------------------------------------------------------|
    |Fn_AL|_BL|_WL|   |   |   |   |   |   |   |   |   |   |     |MR1|
    |---------------------------------------------------------------|
    |FnCaps|   |   |_DL|   |   |   |   |   |   |   |   |        |MS |
    |---------------------------------------------------------------|
    |        |   |   |_CL|   |_BL|_NL|   |   |   |   |      |   |MR2|
    |---------------------------------------------------------------|
    |Rst |    |    |                        |     |     |   |   |MP2|
    *---------------------------------------------------------------*
